
*= $8000

SETLFS = $FFBA
SETNAM = $FFBD
OPEN = $FFC0
CLOSE = $FFC3

.BYTE <COLD 
.BYTE >COLD 
.BYTE <COLD 
.BYTE >COLD
.BYTE $C3,$C2,$CD,$38,$30 
;===================
COLD		
	SEI
	CLD
	LDX #$FF
	TXS
	JSR $FDA3
;===================
	LDA #$00
	TAY
- 
	STA $0100	,Y
	INY
	BNE - 
+	
	JSR INITMEM
	JSR $FF5B
	JSR $E453
	JSR $E3BF
	
	LDA #$37
	STA $01
	STA $C0
;D 809C /JSR 864F
JSR SVECL

	LDX #$FB
	TXS
	CLI
	LDA #$00
	STA $C6
	LDA #$0E
	STA $D020
	STA $0286
	LDA #$06
	STA $D021

	JSR $E422
	LDA #$01
	STA $0286
	LDA #<MY_CORE_NAME
	LDY #>MY_CORE_NAME
	JSR $AB1E
	
	
	LDA $02
	BEQ +
		LDY #$00
		LDA #<TEXT_HELP
		STA $FB
		LDA #>TEXT_HELP
		STA $FC
	-	LDA ($FB),Y
		BEQ +
		JSR $E716
		INC $FB
		BNE -
		INC $FC
		BNE -
		
+
	-
		LDA #$40
		CMP $C5
		BNE -
		LDA $028D
		BNE -
		LDA #$00
		STA $C6
		

BASICQUIT
	
	LDA #>$A473
	PHA
	LDA #<$A473
	PHA
	JMP DETACH_CART


SVECL
	JSR CHECK_NTSC
	JSR SETUP_SWITCH
	BNE +
	LDA #$00
	.BYTE $2C
+	LDA #$01
	STA $02
		LDA #$1B
		STA $D011
SVECL2
	php
	sei
	LDA #$DF
	STA $0331
	STA $0333
	STA $0303
	LDA #<M_WAIT
	STA $0302
	LDA #<FASTLOAD
	STA $0330
	LDA #$01
	STA $0286
	LDA #<SAVE_VEC
	STA $0332
	plp
	RTS
;=====
WHITE_COLOR
	LDA #$0E
	STA $D020
	LDA #$06
	STA $D021

	LDA #$01
	STA $0286
	LDX #$00
-
	STA $D800,X
	STA $D900,X
	STA $DA00,X
	STA $DAE8,X
	INX
	BNE -
	RTS
;======
INITMEM  LDA #$00
         TAY
INIMEM1  STA $02,Y
         STA $0201,Y
         STA $0300,Y
         INY
         BNE INIMEM1
         LDX #$3C
         LDY #$03
         STX $B2
         STY $B3
         LDA #$A0
         STA $0284
         STA $C2
         LDA #$08
         STA $0282
         LSR A
         STA $0288
         LDY #$1F
INIMEM2  LDA $FD30,Y
         STA $0314,Y
         DEY
         BPL INIMEM2
         RTS
;======
MY_NTSC = $02A6
CHECK_NTSC
php
		SEI
		BIT $D011
		BMI *-3
		BIT $D011
		BPL *-3
LDA #$0B
STA $D011
		LDX #$20
		DEX
		BNE *-1

	-
		LDA $D012
		BEQ STORE_NTSC
		TAX
		CMP $D012
		BEQ *-3
		BNE -
STORE_NTSC
		CPX #$20
		ADC #$00
		STA MY_NTSC
		plp
		RTS
;=============
SETUP_SWITCH
		LDY #$00
	-
		LDA CODE_SWITCH,Y
		STA $0400,Y
		INY
		BNE -
		LDY #$00
		SEI
		JSR $0400
		PHP
		JSR $E544
		PLP
		RTS
;---
CODE_SWITCH
.LOGICAL $0400
STARA_PROC
		
		SEI
		LDY #$00
		LDA #$37
		STA $01
	-
		LDA #$00
		STA $DE00
		LDX CORE_SWITCH,Y
		LDA #$23
		STA $DE00
		TXA
		STA $9F00,Y
		INY
		CPY #$F8
		BNE -
		LDY #$07
	-
		LDA WIZYTOWKA,Y
		CMP $9FF8,Y
		BNE +
		DEY
		BPL -
		INY
	+	PHP			
		LDY #$07
	-
		LDA WIZYTOWKA,Y
		STA $9FF8,Y
		DEY
		BPL -
		INY
		STY $DE00		
		PLP
		RTS	
.HERE


FC3_FROM
		LDY #$00
FC3_TO = *+1
		BIT $08A0
		BIT $9D
		BPL +
		JSR OUT_COMMU
		LDA $AF
		JSR FC3_HEX
		LDA $AE
		JSR FC3_HEX
	+
	-
		RTS
FC3_DATA1
		.TEXT " FROM $"
		.BYTE 0
		.TEXT " TO $"
		.BYTE 0
OUT_COMMU
	-
		LDA FC3_DATA1,Y
		BEQ --
		JSR $E716
		INY
		BNE -
;------------
FC3_HEX
		JSR FC3_HEX2
		JSR $E716
		TYA
		JMP $E716
FC3_HEX2
		PHA
		AND #$0F
		JSR FC3_HEX3
		TAY
		PLA
		LSR
		LSR
		LSR
		LSR
FC3_HEX3
		CLC
		ADC #$F6
		BCC +
		ADC #$06
	+
		ADC #$3A
		RTS
;---------
FC3_MW3
		PHA
		LDA $BA
		JSR $FFB1
		PLA
		JMP $FF93
START_LOAD
		JMP LOOP_LOAD
;---------
FC3LOAD

		STA $93 ;FLAGA LOAD VERIFY - LOAD = 0 , VERIFY = 1
		LDY #$37
		STY $01
		LDY #$00
		STY $D015
		jsr CHECK_NTSC
		lda #$1b
		sta $d011
		JSR WHITE_COLOR
		cli
		JSR KOPIUJ_NAZWE_ZBIORU

		LDY $BA
		CPY #7
		BNE +
		JMP TURBO_ABC
	+	CPY #$08
		BCS +
	-
		LDA #$00
		STA $B9
		JSR $FFAB
		JMP ($8000)
	+
		CPY #12
		BCS -
		LDA $B7
		BNE +
		JSR SETUP_FILE_WILDCARD
	+
		;LDA $93
		;BNE -

		LDY #$00
		LDA ($BB),Y
		CMP #$24
		BNE +
		JMP CONT_WITH_DIR
	+	LDX $B9
		CPX #$02
		BEQ -

		JSR FC3_TEST1
		JSR INITDISK
		LDA #$60
		STA $B9
		JSR FC3_TEST3
		LDA $BA
		JSR $ED09
		LDA $B9
		JSR $EDC7
		JSR TEST_F_NOT_FOUND
		JSR $EE13
		STA $AE
		sta $ac
		JSR TEST_F_NOT_FOUND
		JSR $EE13
		STA $AF
		sta $ad
		JSR TEST_F_NOT_FOUND
		TXA
		BNE +
		LDA $C3
		STA $AE
		LDA $C4
		STA $AF
	+

		JSR FC3_TEST4

		LDA $AF
		CMP #$04 ;LOADADRES NISKI
		BCS +
		
		;JMP $F4F3 ;JMP NORMAL LOAD
		JSR $F642
		JMP ($8000)

	+
		;JSR $FFAB
		;JSR $F32F
		
		LDX #$00
	-
		LDA COPY_TO_STACK,X
		STA $0100,X
		INX
		CPX #_LEN_LOOP_LOAD
		BNE -

		JSR FC3_FROM

		LDA #$06
		STA $93
		
		LDA #<FC3_LOADER
		LDY #>FC3_LOADER
		LDX #$04
		JSR FC3_MW

		LDA #$9A
		JSR $FFA8
		LDA #$05
		JSR $FFA8
		JSR $FFAE
		SEI
		LDA $D011
		TAX
		AND #$10
		STA $95
;SLEDZIC OD 9B10
		
		TXA
		AND #$EF
		STA $D011
		LDA $DD00
		AND #$07
		ORA $95
		STA $95
		
		LDA $C1
		STA $A4
		LDA $C2
		STA $B9
		
		SEC
		LDA $AE
		SBC #$02
		STA $90
		LDA $AF
		SBC #$00
		STA $A3

		JMP START_LOAD
;--------------------
TEST_F_NOT_FOUND
		LDA $90
		BEQ +
		JMP F_NOT_FOUND			
	+	RTS

;====
KOPIUJ_NAZWE_ZBIORU
;-
		PHP
		PHA
		TYA
		PHA
		
		LDY #$1F
	-
		LDA COPYNAME,Y
		STA $0110,Y
		DEY
		BPL -
		JSR $0110
		LDA #$30
		STA $BB
		LDA #$01
		STA $BC
		lda $0130
		cmp #"*"
		bne +
		JSR SETUP_FILE_WILDCARD
	+
		PLA
		TAY
		PLA
		PLP
		RTS
COPYNAME
		PHP
		SEI
		LDY #$12
	-
		INC $01
		LDA ($BB),Y
		DEC $01
		STA $0130,Y
		DEY
		BPL -
		PLP	
		RTS

;=====================
LOOP_LOAD		
	-	BIT $DD00
		BMI ++
		CLI
		PHP
		LDA $95
		AND #$07
		STA $DD00
		
		LDA $95
		AND #$10
		ORA $D011
		STA $D011
		
		LDA $A4
		STA $C1
		LDA $B9
		STA $C2
		
		LDA #$00
		STA $A3
		STA $94
		STA $90
		LDA #$60
		STA $B9
		LDA #$E0
		JSR FC3_MW3
		JSR $FFAE
		PLP
		BVS +
		LDA #$1D
		SEC
		RTS
	+	LDA #$40
		STA $90
		JSR FC3_TO
		jsr $f642
		;JMP $F5A9

		lda $ac
		cmp $2b
		bne GR_0
		lda $ad
		cmp $2c
		bne GR_0
		lda $ae
		sta $2d
		lda $af
		sta $2e
		jsr $a659
		JMP GOTO_READY
GR_0		bit $9d
		bmi GOTO_READY
		CLC
		JMP DETACH_CART
GOTO_READY
		LDX #$FB
		TXS
		LDA #>$E385
		PHA
		LDA #<$E385
		PHA
		
		JMP DETACH_CART
		
		;TU LADOWANIE
	+	BVS LOOP_LOAD
		LDA #$20
		STA $DD00
		BIT $DD00
		BVC *-3
		
		LDA #$00
		STA $DD00
		
		JSR GET4FC3PAL
		LDA #$FE
		STA $A5
		LDA $C3
		CLC
		ADC $A3
		TAX
		ASL $C3
		PHP
		SEC
		LDA $90
		SBC $C3
		STA $93
		BCS +
		DEX
	+	PLP
		BCC +
		DEX
	+	STX $94
		ROR $C3
		LDX $C2
		BEQ +
		DEX
		STX $A5
		TXA
		CLC
		ADC $93
		STA $AE
		LDA $94
		ADC #$00
		STA $AF
	+	LDY #$00
JMP LOOP_LOAD2
COPY_TO_STACK
.LOGICAL $0100
LOOP_LOAD2
		LDA $C3
		BNE +
		JSR GET4FC3PAL
		INC $01
		LDY #$02
		LDX #$02
		BNE ++
	+	LDA $C1
		INC $01
		STA ($93),Y
		DEC $01
		INY
	-	TYA
		PHA
		JSR GET4FC3PAL
		INC $D020
		PLA
		TAY
		INC $01
		LDX #$03
	-
	+	CPY $A5
		BCS +
		LDA $C1,X
		STA ($93),Y
	+	INY
		CPY #$FE
		BCS +
		DEX
		BPL -
		LDA #$37
		STA $01
		JMP --
	+	LDA #$37
		STA $01
		lda #$0e
		sta $d020
		JMP LOOP_LOAD
_LEN_LOOP_LOAD = * -LOOP_LOAD2
.HERE	
;=== SEARCHING FOR
FC3_TEST1
		LDA $9D
		BPL +
		LDY #$0C
		JSR FC3_TEST2
		LDA $B7
		BEQ +
		LDY #$17
		JSR FC3_TEST2
		LDY $B7
		BEQ +
		LDY #$00
	-
		LDA ($BB),Y
		JSR $E716
		INY
		CPY $B7
		BNE -
	+
		RTS	
;===
FC3_TEST4
		LDY #$49
		LDA $93
		BEQ +
		LDY #$59
		BIT $51A0
	+
		BIT $9D
		BPL +
		
;===
FC3_TEST2	;KOMUNIKAT SEARCHING FOR
		LDA $F0BD,Y
		PHP
		AND #$7F
		JSR $E716
		INY
		PLP
		BPL FC3_TEST2
	+
		CLC
		RTS
INITDISK
		JSR TESTPR2
		LDA #"I"
		JSR $EDDD
		JMP $EDFE
TESTPRESENT
		JSR TESTPR2
		JMP $EDFE
TESTPR2
		LDA #$00
		STA $90
		LDA $BA
		JSR $ED0C
		LDA #$6F
		JSR $EDB9
		BIT $90
		BMI DNOTPR
		RTS
;===
FC3_TEST3 ;OTWARCIE ZBIORU NA IEC
		LDY #$00
		STY $90
		LDA $BA
		JSR $ED0C
		LDA $B9
		ORA #$F0
		JSR $EDB9
		LDA $90
		BEQ IS_DEV
		;PLA
		;PLA

F_NOT_FOUND
		LDX #$04
		.BYTE $2C
DNOTPR
		LDX #$05
ERROR_IN_X
		STX $C3
		SEI
		LDX #$FB
		TXS
		LDY $0301
		LDX $0300
		BNE +
		DEY
	+	DEX
		TYA
		PHA
		TXA
		PHA
		LDX $C3
		LDA #$FF
		STA $3A
		JMP DETACH_CART
IS_DEV
	-
		LDA ($BB),Y
		JSR $EDDD
		INY
		CPY $B7
		BNE -
		JMP $F654
;=======
FC3_MW
		STA $C3
		STY $C4
		
		LDY #$00
	-
		LDA #$57 ;"W"
		JSR FC3_MW2
		TYA
		JSR $FFA8
		TXA
		JSR $FFA8
		LDA #$20
		JSR $FFA8
	-
		LDA ($C3),Y
		JSR $FFA8
		INY
		TYA
		AND #$1F
		BNE -
		JSR $FFAE
		TYA
		BNE --
		INC $C4
		INX
		CPX $93
		BCC --
		LDA #$45
		PHA
		LDA $BA
		JSR $FFB1
		LDA #$6F
		JSR $FF93
		LDA #$4D
		JSR $FFA8
		LDA #$2D
		JSR $FFA8
		PLA
		JMP $FFA8
FC3_MW2
		PHA
		LDA #$6F
		JSR FC3_MW3
		LDA #$4D
		JSR $FFA8
		LDA #$2D
		JSR $FFA8
		PLA
		JMP $FFA8
;------------
;======================================
CODE_SAVE

.BYTE $AD,$12,$06,$AA,$4A,$69,$03,$85
.BYTE $95,$85,$31,$8A,$69,$06,$85,$32
.BYTE $20,$64,$05,$F0,$0D,$85,$81,$AA
.BYTE $E8,$8E,$11,$06,$A9,$00,$85,$80
.BYTE $F0,$12,$AD,$FC,$02,$D0,$0A,$AD
.BYTE $FA,$02,$D0,$05,$A9,$72,$4C,$69
.BYTE $F9,$20,$1E,$F1,$A0,$00,$84,$94
.BYTE $A5,$80,$91,$94,$C8,$A5,$81,$91
.BYTE $94,$C8,$20,$64,$05,$91,$30,$C8
.BYTE $CC,$11,$06,$D0,$F5,$20,$50,$01
.BYTE $E6,$B6,$AE,$12,$06,$A5,$81,$95
.BYTE $07,$A5,$80,$D5,$06,$F0,$B1,$95
.BYTE $06,$4C,$18,$F4,$A9,$00,$8D,$00
.BYTE $18,$A9,$04,$2C,$00,$18,$D0,$FB
.BYTE $85,$C0,$85,$C0,$AD,$00,$18,$0A
.BYTE $EA,$EA,$0D,$00,$18,$0A,$0A,$0A
.BYTE $0A,$8D,$C0,$00,$AD,$00,$18,$0A
.BYTE $EA,$EA,$0D,$00,$18,$29,$0F,$05
.BYTE $C0,$85,$C0,$A9,$02,$8D,$00,$18
.BYTE $A5,$C0,$60,$EA,$A9,$EA,$8D,$72
.BYTE $05,$8D,$73,$05,$A2,$11,$BD,$89
.BYTE $05,$9D,$8A,$05,$CA,$10,$F7,$A2
.BYTE $64,$BD,$74,$F5,$9D,$4F,$01,$CA
.BYTE $D0,$F7,$A9,$60,$8D,$B4,$01,$E8
.BYTE $86,$82,$86,$83,$20,$95,$DF,$E8
.BYTE $8E,$00,$18,$E8,$D0,$FD,$8D,$13
.BYTE $06,$0A,$8D,$12,$06,$AA,$A9,$40
.BYTE $8D,$F9,$02,$B5,$06,$F0,$1B,$85
.BYTE $0A,$A9,$E0,$85,$02,$A5,$02,$30
.BYTE $FC,$C9,$02,$90,$EE,$C9,$72,$D0
.BYTE $03,$4C,$C8,$C1,$AE,$13,$06,$4C
.BYTE $0A,$E6,$A2,$09,$BD,$07,$06,$9D
.BYTE $4F,$01,$CA,$D0,$F7,$4C,$50,$01
.BYTE $20,$A5,$DB,$20,$F4,$EE,$4C,$27
.BYTE $D2,$00,$48,$A5,$BA,$20,$B1,$FF
.BYTE $68,$4C,$93,$FF,$A9,$6F,$48,$A5
.BYTE $BA,$20,$B4,$FF,$68,$4C,$96,$FF
.BYTE $20,$32,$A6,$20,$16,$E7,$98,$4C
.BYTE $16,$E7,$48,$29,$0F,$20,$3E,$A6
.BYTE $A8,$68,$4A,$4A,$4A,$4A,$18,$69
.BYTE $F6,$90,$02,$69,$06,$69,$3A,$60
.BYTE $20,$C1,$A6,$D0,$FA,$A9,$07,$85
.BYTE $93,$A9,$00,$A0,$A5,$A2,$05,$20
.BYTE $D5,$A6,$AD,$30,$03,$C9,$20,$F0
.BYTE $09,$A9,$9C,$20,$A8,$FF,$A9,$05
.BYTE $D0,$07,$A9,$AF,$20,$A8,$FF,$A9
.BYTE $05,$20,$A8,$FF,$20,$AE,$FF,$78
.BYTE $AD,$15,$D0,$85,$93,$8C,$15,$D0
.BYTE $AD,$00,$DD,$29,$07,$85,$A4,$09
.BYTE $10,$85,$A5,$8D,$00,$DD,$4C,$F6
.BYTE $A9,$A0,$00,$2C,$A0,$08,$24,$9D
.BYTE $10,$0D,$20,$A8,$A6,$A5,$AF,$20
.BYTE $28,$A6,$A5,$AE,$4C,$28,$A6,$60
.BYTE $B9,$B3,$A6,$F0,$FA,$20,$16,$E7
.BYTE $C8,$D0,$F5,$20,$46,$52,$4F,$4D
.BYTE $20,$24,$00,$20,$54,$4F,$20,$24
.BYTE $00,$20,$1C,$A6,$20,$A5,$FF,$A8
.BYTE $20,$A5,$FF,$C9,$0D,$D0,$F9,$20
.BYTE $AB,$FF,$C0,$30,$60,$85,$C3,$84
.BYTE $C4,$A0,$00,$A9,$57,$20,$07,$A7
.BYTE $98,$20,$A8,$FF,$8A,$20,$A8,$FF
.BYTE $A9,$20,$20,$A8,$FF,$B1,$C3,$20
.BYTE $A8,$FF,$C8,$98,$29,$1F,$D0,$F5
.BYTE $20,$AE,$FF,$98,$D0,$DD,$E6,$C4
;=======================================
FC3_LOADER

.BYTE $A5,$43,$85,$C1,$20,$82,$05,$50
.BYTE $FE,$B8,$AD,$01,$1C,$99,$25,$00
.BYTE $C8,$C0,$07,$D0,$F2,$20,$56,$F5
.BYTE $50,$FE,$B8,$AD,$01,$1C,$91,$30
.BYTE $C8,$C0,$05,$D0,$F3,$20,$97,$F4
.BYTE $A2,$05,$A9,$00,$55,$15,$CA,$D0
.BYTE $FB,$A8,$F0,$03,$4C,$0B,$F4,$E8
.BYTE $B5,$12,$D5,$16,$D0,$F6,$CA,$10
.BYTE $F7,$20,$E8,$F7,$A6,$19,$E4,$43
.BYTE $B0,$EA,$A5,$53,$9D,$0F,$06,$A5
.BYTE $54,$9D,$FA,$05,$A9,$FF,$9D,$24
.BYTE $06,$C6,$C1,$D0,$A7,$A9,$01,$85
.BYTE $C3,$A6,$09,$A5,$C2,$9D,$24,$06
.BYTE $E6,$C2,$BD,$0F,$06,$C5,$08,$D0
.BYTE $0A,$BD,$FA,$05,$AA,$E6,$C3,$D0
.BYTE $EA,$F0,$B9,$C9,$24,$B0,$B5,$85
.BYTE $08,$BD,$FA,$05,$85,$09,$20,$82
.BYTE $05,$C8,$50,$FE,$B8,$AD,$01,$1C
.BYTE $91,$30,$C8,$C0,$04,$D0,$F3,$A0
.BYTE $00,$20,$E8,$F7,$A6,$54,$E4,$43
.BYTE $B0,$92,$BD,$24,$06,$C9,$FF,$F0
.BYTE $DD,$86,$C0,$20,$56,$F5,$50,$FE
.BYTE $B8,$AD,$01,$1C,$91,$30,$C8,$D0
.BYTE $F5,$A0,$BA,$50,$FE,$B8,$AD,$01
.BYTE $1C,$99,$00,$01,$C8,$D0,$F4,$20
.BYTE $E8,$F7,$A5,$53,$F0,$04,$A9,$00
.BYTE $85,$54,$85,$34,$85,$C1,$A6,$C0
.BYTE $BD,$24,$06,$85,$53,$A9,$FF,$9D
.BYTE $24,$06,$20,$D0,$F6,$A9,$42,$85
.BYTE $36,$A0,$08,$8C,$00,$18,$AD,$00
.BYTE $18,$4A,$90,$FA,$A0,$00,$C6,$36
.BYTE $8C,$00,$18,$D0,$07,$C6,$C3,$D0
.BYTE $85,$4C,$18,$F4,$A4,$C1,$B1,$30
.BYTE $4A,$4A,$4A,$85,$5C,$B1,$30,$29
.BYTE $07,$85,$5D,$C8,$D0,$05,$C8,$84
.BYTE $31,$A0,$BA,$B1,$30,$0A,$26,$5D
.BYTE $0A,$26,$5D,$4A,$4A,$4A,$85,$5A
.BYTE $B1,$30,$4A,$C8,$B1,$30,$2A,$2A
.BYTE $2A,$2A,$2A,$29,$1F,$85,$5B,$B1
.BYTE $30,$29,$0F,$85,$58,$C8,$B1,$30
.BYTE $0A,$26,$58,$4A,$4A,$4A,$85,$59
.BYTE $B1,$30,$0A,$0A,$0A,$29,$18,$85
.BYTE $56,$C8,$B1,$30,$2A,$2A,$2A,$2A
.BYTE $29,$07,$05,$56,$85,$56,$B1,$30
.BYTE $29,$1F,$85,$57,$C8,$84,$C1,$A0
.BYTE $08,$8C,$00,$18,$B6,$55,$BD,$C2
.BYTE $05,$8D,$00,$18,$BD,$DA,$05,$B6
.BYTE $54,$8D,$00,$18,$88,$D0,$EF,$4C
.BYTE $F6,$04,$A2,$03,$86,$31,$E8,$D0
.BYTE $03,$4C,$0B,$F4,$20,$56,$F5,$50
.BYTE $FE,$B8,$AD,$01,$1C,$C5,$24,$D0
.BYTE $ED,$60,$A2,$00,$8E,$00,$18,$86
.BYTE $C2,$A5,$19,$85,$09,$A5,$18,$85
.BYTE $08,$A9,$E0,$85,$01,$A5,$01,$30
.BYTE $FC,$C9,$02,$B0,$0C,$A5,$08,$D0
.BYTE $F0,$A9,$02,$8D,$00,$18,$4C,$94
.BYTE $C1,$E8,$A0,$0A,$8C,$00,$18,$4C
.BYTE $0A,$E6,$00,$0A,$0A,$02,$00,$0A
.BYTE $0A,$02,$00,$00,$08,$00,$00,$00
.BYTE $08,$00,$00,$02,$08,$00,$00,$02
.BYTE $08,$00,$00,$08,$0A,$0A,$00,$00
.BYTE $02,$02,$00,$00,$0A,$0A,$00,$00
.BYTE $02,$02,$00,$08,$08,$08,$00,$00
.BYTE $00,$00,$FF,$FF,$FF,$FF,$FF,$FF
ENDLOADER
;======================================================
M_WAIT2
		JSR SVECL2
		BIT $9D
		BPL +
		
		JSR CALLER
		;JMP $A486  
		+
SYNTAX_ERR
		lda #$a4
		PHA
		LDA #$85
		PHA
		JMP DETACH_CART
;=================
CALLER
		LDA #$38
		STA $DC05
		LDX #$FF
		STX $8F
		INX
	-
		JSR FKTR
		CMP #$0D
		BEQ CALLER_EXIT
		STA $0200,X
		INX
		CPX #$54
		BCC -
		JMP $A571
CALLER_EXIT
		LDA #$40
		STA $DC05

		BIT $9D ;TRYB BEZPOSREDNI?
		BPL +
		TXA
		PHA
		jsr ANALYSE_LINE
		PLA
		TAX
		+
		LDA #$40
		STA $DC05
		LDA #$0D

		JMP $AACA
;=========== AUTO5 NIE WYKORZYSTANE JESZCZE - DO CARTA
AUTO5
		STY $DE00
		CLI
	-
		LDA $C6
		STA $CC
		BEQ -
		STX $DE00
		RTS
;=================
FKTR
		;JSR $E112
		TYA
		PHA
		TXA
		PHA
		
		LDA #$00
		STA $CA
		LDA $D6
		STA $C9
		
		LDA $D0
		BEQ FKTR2
		JMP $E63A
FKTR1	JSR $E716
FKTR2
		LDX #$0D
FKTR3
		LDA AUTO5,X
		STA $0210,X
		DEX
		BPL FKTR3
		INX
		LDY #$02
		JSR $0210

;>>>>>>>>>>>>>>
;		CLI
;	-
;		LDA $C6
;		STA $CC
;		BEQ -
;^^^^^^^^^^^
		
		STA $0292
		SEI
		LDA $CF
		BEQ FKTR4
		LDA $CE
		LDX $0287
		LDY #$00
		STY $CF
		JSR $EA13
FKTR4	JSR $E5B4
		
		JMP TEST_FKEYS
FKTR4A
		CMP #$0D
		BNE FKTR1
		LDA $D3
		STA $8E
		JMP $E602
;=================
TEST_FKEYS

TEST_F8
		CMP #$8C
		BNE TEST_F7
		
		LDY #$00
	-
		LDA MY_F8,Y
		BEQ +
		JSR $E716
		INY
		BNE -
	+
REPETUJ_FKTR
		LDA #$0D
POWROT_FKTR
		JMP FKTR4A
TEST_F7 ;DIR
		CMP #$88
		BNE TEST_F3
		JSR $E544
		JMP CONT_WITH_DIR
TEST_F3 ;RUN:
		CMP #$86
		BNE TEST_F4
		LDA #"R"
		JSR $E716
		LDA #"u"
		JSR $E716
		LDA #":"
		JSR $E716
		JMP REPETUJ_FKTR
TEST_F4 ;F4 - SYS 64738
		CMP #$8A
		BNE TEST_F5
		JSR PREP_F4_ZAP
		JMP $0100
TEST_F5
		CMP #$87
		BNE TEST_F6
		JMP WYKONAJ_LOAD
TEST_F6   ;GOTO GEOACTION
		CMP #$8B
		BNE TEST_F1
		JMP WYKONAJ_F6
TEST_F1
		CMP #$85
		BNE TEST_F2
		JSR WYKONAJ_PARRENT
		JMP POWROT_FKTR
		
TEST_F2
		CMP #$89
		BNE TEST_XX
		JSR WYKONAJ_ROOT
		JMP POWROT_FKTR
TEST_XX
KONIEC_TESTOW_FKEY		
		JMP POWROT_FKTR
;***************************************8
;================
WYKONAJ_ROOT
		JSR SETUP_BA
		JSR SETUP_FILE_WILDCARD
		JSR PARRENT2
		
		LDY #$00
	-
		LDA MY_F2,Y
		BEQ +
		JSR $E716
		INY
		BNE -
	+
		LDY #$04
		STY $B7
	-
		LDA ROOT_TXT,Y
		STA ($BB),Y
		DEY
		BPL -
		JSR OPENCLOSE
		JMP CONT_WITH_DIR

;---
MY_F2
		.BYTE 147, $5E
		.TEXT " GO TO ROOT DIR..."
		.BYTE 13,0	
ROOT_TXT
		.TEXT "CD//"
;================
WYKONAJ_PARRENT
		JSR SETUP_BA
		JSR SETUP_FILE_WILDCARD
		
		LDY #$00
	-
		LDA MY_F1,Y
		BEQ +
		JSR $E716
		INY
		BNE -
	+
		JSR PARRENT2
		
CONT_WITH_DIR
		JSR DIR
		JSR STATUS
		LDA #$17
		STA $D018
		JMP GOTO_READY
PARRENT2
		LDY #$04
		STY $B7
	-
		LDA PARRENT_TXT,Y
		STA ($BB),Y
		DEY
		BPL -
		JMP OPENCLOSE

MY_F1
		.BYTE 147, $5F
		.TEXT " GO TO PARRENT DIR..."
		
		.BYTE 13,0
PARRENT_TXT
		.TEXT "CD:"
		.BYTE $5F
;================
WYKONAJ_F6
		LDX #$20
	-
		LDA COD_F6,X
		STA $0110,X
		DEX
		BPL -
	-
		LDA #$40
		CMP $C5
		BNE -
		LDA $028D
		BNE -
		JMP $0110
COD_F6
		SEI
		LDA #$37
		STA $01
		LDA #$00
		STA $DE00
		LDA #$00
		STA $DE01
		JMP ($FFFC)
		
;================
WYKONAJ_LOAD

		JSR SETUP_BA
		JSR SETUP_FILE_WILDCARD
		JSR SETUP_LINE
		JSR TEST_EMPTY_LINE
		BCS +
		JSR PRINT_F5
		
		;JMP REPETUJ_FKTR
	-
		LDA #$87
		JMP POWROT_FKTR
		
GO_LOAD_FROM_TOKEN

		STA $D0
		LDA #$00
		JMP ($0330)
	+
		JSR TEST_2CH_CUDZ
		BCS -
		LDY #$00
	-
		JSR GET_FROM_SCREEN
		CMP #$22
		BNE -

	-
		;JSR GET_FROM_SCREEN
		JSR $E632
		CMP #$22
		BEQ +
		STA ($BB),Y
		;STA $0400,Y
		INY
		BNE -
	+
		STY $B7
		
		SEI
		LDA #"/"

		LDY #$00
		STY $D0
	-
		STA ($D1),Y
		INY
		LDA ($D1),Y
		CMP #$22
		BEQ +
		LDA #$20
		BNE -
	+
;		LDA #$00
;		STA $D0
;		JSR GO_CR
		CLI
		
___M		JSR TEST_DIR_FILE
		BCS +
	-
		JSR CHANGE_DIR	
		JSR $E544
		JMP CONT_WITH_DIR
	+	
		JSR TEST_D64_FILE
		BCC -
		JSR TEST_M2I_FILE
		BCC -

		JSR GO_CR
		LDA #$00 ;03
		JMP GO_LOAD_FROM_TOKEN
		
		RTS
;===

CHANGE_DIR
		JSR SETUP_BA
		JSR KOPIUJ_NAZWE_ZBIORU
		LDY #$1F
	-
		LDA $0130,Y
		STA $0135,Y
		DEY
		BPL -
		LDY #$04
	-
		LDA CHG_DIR_TXT,Y
		STA $0130,Y
		DEY
		BPL -
		LDA $B7
		CLC
		ADC #$05
		STA $B7
		JSR OPENCLOSE
		JSR SILENT_STATUS
		BCC +
		DEC $B7
		LDY #$00
	-
		LDA $0133,Y
		STA $0132,Y
		INY
		CPY #$20
		BCC -
		JSR OPENCLOSE
	+
		RTS

		
OPENCLOSE
		LDX $BA
		LDA #1
		LDY #15
		JSR SETLFS
		JSR OPEN
		LDA #1
		JMP CLOSE
;============
TEST_M2I_FILE
		JSR TEST_2CH_CUDZ
		BCC +
NO_M2I	SEC
		RTS
	+
		LDX #$00
	-
		DEY		
		LDA ($D1),Y
		AND #%10111111
		CMP M2I_TEXT,X
		BNE NO_M2I
		INX
		CPX #4
		BNE -
IS_M2I
		CLC
		RTS
M2I_TEXT
		.BYTE $09,$32,$0D,$2E ;I2M.
;=============
TEST_D64_FILE
		JSR TEST_2CH_CUDZ
		BCC +
NO_D64	SEC
		RTS
	+
		LDX #$00
	-
		DEY		
		LDA ($D1),Y
		AND #%10111111
		CMP D64_TEXT,X
		BNE NO_D64
		INX
		CPX #4
		BNE -
IS_D64
		CLC
		RTS
D64_TEXT 	.BYTE $34,$36,$04,$2E ;46D.
;=============
TEST_DIR_FILE
		JSR TEST_2CH_CUDZ
		BCC +
BAD_TEST
		RTS
	+
		LDX #$00
	-
		INY
		CPY #$28
		BCS BAD_TEST
		LDA ($D1),Y
		CMP #$20
		BEQ -
	-
		LDA ($D1),Y
		AND #%10111111
		CMP DIR_TEXT,X
		BNE BAD_TEST
		INY
		INX
		CPX #3
		BCC -
		CPY #$28
		BCS +
		LDA ($D1),Y
		CMP #$20
		BNE BAD_TEST
	+
		CLC
		RTS
SILENT_STATUS
		JSR SETUP_BA
		LDA $BA
		JSR $FFB4
		LDA #$6F
		JSR $FF96
		JSR $FFA5
		TAX
	-
		JSR $FFA5
		CMP #$0D
		BNE -
		JSR $FFAB
		TXA
		CMP #$30
		BNE +
		CLC
		RTS
	+	SEC
		RTS
;---	
CHG_DIR_TXT	.TEXT "CD//:"
DIR_TEXT 	.BYTE $04,$09,$12
;===============================
;<<
GET_FROM_SCREEN
		LDA #$28
		STA $C8
		LDA #$03
		STA $D0
		JMP $E632
;*****************
TEST_2CH_CUDZ
;ZWRACA W CARRY ZNALEZIENIE C = 0
;JAK ZNALEZIONY - W X PIERWSZY, W Y 2GI CUDZUSLOW
		
		LDY #$00
		LDA ($D1),Y
		CMP #$22
		BNE +
		RTS
	+
	
	-
		INY
		CPY #$26
		BCC +
		RTS
	+	LDA #$22
		CMP ($D1),Y
		BEQ +
		BNE -
	+
		TYA
		TAX
	-
		INY
		CPY #$28
		BCC +
		RTS
	+	LDA #$22
		CMP ($D1),Y
		BEQ +
		BNE -
	+	CLC
		RTS
;====
TEST_EMPTY_LINE
		
		LDY #$27
		LDA #$20
	-
		CMP ($D1),Y
		BNE +
		DEY
		BPL -
		CLC
		RTS
	+	SEC
		RTS
;====
SETUP_LINE
		LDA $D6
		CMP #$18
		BCC +
		LDA #$91
		JSR $E716
GO_CR
		LDA #$0D
	-
		JMP $E716
	+
		JSR GO_CR
		LDA #$91
		BNE -
;====
SETUP_FILE_WILDCARD
		
		lda #$3a
		sta $0130
		LDA #"*"
		STA $0131
		LDA #$01
		STA $B9
		LDA #$02
		LDX #<$0130
		LDY #>$0130		
		JMP $FFBD
;=================
MY_F8
	.BYTE 147
	.TEXT "Li"
	.BYTE 0
PREP_F4_ZAP
		SEI
		LDA #$37
		STA $01
		
		LDX #$50
	-
		LDA MY_F4,X
		STA $0100,X
		DEX
		BPL -
		
		RTS
MY_F4
		SEI
		LDA #$06
		STA $DE00
		LDA #$04
		STA $DE00
		
		LDA #$FF
		STA $DE01
		JMP ($FFFC)
PRINT_READY
		LDA #$76
		LDY #$A3
		JMP $AB1E
;======================================================
MY_F5
		.TEXT "/*"
		.BYTE 0
PRINT_F5
		LDA #<MY_F5
		LDY #>MY_F5
		JMP $AB1E
;====================
STATUS
		JSR SETUP_BA
		JSR TESTPRESENT
		LDA $BA
		JSR $ED09
		LDA #$6F
		JSR $EDC7
		JSR $EE13
		PHA
		JSR $E716
	-
		JSR $EE13
		JSR $E716
		CMP #$0D
		BNE -
		JSR $EDEF
		PLA
		CMP #$30
		RTS
		
;===========
SETUP_BA
		PHP
		PHA
		LDA $BA
		CMP #$08
		BCS +
	-
		LDA #$08
	+
		CMP #12
		BCS -
		STA $BA
		
		
		PLA
		PLP
		RTS
;=====================================
DIR      LDA #$24
         STA $22
         LDA #$17
         STA $D018
         JSR WHITE_COLOR
         LDA #$01
         LDX #$22
         LDY #$00
         STY $C6
         JSR $FFBD
         LDY #$60
         JSR SETUP_BA
         LDX $BA
         CPX #$08
         BCS DIR1
         LDX #$08
DIR1     JSR $FFBA
		JSR INITDISK
		LDA #$0D
		JSR $E716 ;JSR $FFD2
         JSR $F3D5
         LDA $BA
         JSR $FFB4
         LDA $B9
         JSR $FF96
         LDX #$03
DIR2     JSR $FFA5
         STA $C3
         JSR $FFA5
         STA $C4
         LDY $90
         BNE DIR6
         DEX
         BNE DIR2
         LDX $C3
         TAY
         JSR $BDCD
         LDA #$20
DIR3     JSR $E716
         LDX $90
         BNE DIR6
         JSR $FFA5
         BNE DIR3
         LDA #$0D
         JSR $E716
         JSR $FFE4
         BEQ DIR5
         CMP #$03
         BEQ DIR6
DIR4     JSR $FFE4
         BEQ DIR4
DIR5     LDX #$02
         CMP #$03
         BNE DIR2
DIR6     JMP $F642
;=====================================
EMPTY_LINE_TEST
		LDY #$00
	-	
		LDA ($D1),Y
		CMP #$20
		BNE +
		INY
		CPY #$28
		BCC -
		RTS
	+	CLC
		RTS
;============
ANALYSE_LINE
		JSR EMPTY_LINE_TEST
		BCC +
		RTS
	+	CMP #$1F
		BEQ LEFT_ARROW
		JMP TESTY_LVS
LEFT_ARROW
		INY
		LDA ($D1),Y
		CMP #$14 ;T 
		BEQ +
		JMP RUN_HEAD_FIT
	+	LDX #$C0
	-
		LDA RN_TASM-1,X
		STA $033F,X
		DEX
		BNE -
		JMP $0340
RN_TASM
	.LOGICAL $0340
		SEI
		JSR SET_FB
		STY $FD
		LDA #$90
		STA $FE

		LDA #$08
		STA $DE00
		JSR COPY_BLOCKS
		LDA #$10
		STA $DE00
		JSR SET_FB
		JSR COPY_BLOCKS
		LDA #$02
		STA $DE00
		JMP $9000
		
COPY_BLOCKS
		LDX #$20
	-
		LDA ($FB),Y
		STA ($FD),Y
		STY $D020
		INY
		BNE -
		INC $FC
		INC $FE
		DEX
		BNE -
		RTS
			
SET_FB
		LDY #$00
		STY $FB
		LDA #$80
		STA $FC
		RTS

.HERE
	
RUN_HEAD_FIT
		LDA #$01
		STA $FD
		LDA #$08
		STA $FE
		LDA #<HF_FILE
		STA $FB
		LDA #>HF_FILE
		STA $FC
		LDY #$00
		LDX #6
		
	-
		LDA ($FB),Y
		STA ($FD),Y
		INY
		BNE -
		INC $FC
		INC $FE
		DEX
		BNE -
		LDA #<ZRESETUJ
		STA $0302
		LDA #>ZRESETUJ
		STA $0303
		LDA #$08
		PHA
		LDA #$0C
		PHA
		JMP DETACH_CART
		
		
TESTY_LVS	
		JSR TS1_LVS
		JSR TS2_LVS
		
		CMP #"$"
		BNE +
IS_DIR
		JSR SETUP_BA
		JMP CONT_WITH_DIR
	+
		CMP #$00
		BEQ +
		RTS
	+
		JSR SETUP_BA
		INY
		LDA ($D1),Y
		CMP #$20
		BNE +
		LDA $BA
	-
		STA $BA
		JSR GO_CR
		JSR STATUS
		JMP GOTO_READY
	+	CMP #"8"
		BNE +
		LDA #$08
		BNE -
	+	CMP #"9"
		BNE +
		LDA #$09
		BNE -
	+	CMP #"1"
		BNE NO_CHG_DRV
		INY
		LDA ($D1),Y
		CMP #"0"
		BNE +
		LDA #$0A
		BNE -
	+	CMP #"1"
		BNE +
		LDA #$0B
		BNE -
	+	RTS
NO_CHG_DRV
		CMP #"$"
		BNE +
		JMP IS_DIR
	+	CMP #$09 ;"I"
		BNE +
		JSR INITDISK
		JMP GOTO_READY
		
	+	STY $D3
		JSR TESTPR2
		lda #$20
		sta $02
		ldy $d3
		dey
	-	iny
		cpy #$28
		bcs +
		lda ($d1),y
		cmp #$22
		bne -
	+	sta $02
	-
		LDY $D3
		cpy #$28
		bcs +
		LDA ($D1),Y
		CMP $02
		BEQ +
		JSR GET_FROM_SCREEN
		JSR $EDDD
		JMP -
	+
		LDA #$00
		STA $D0
		JSR $EDFE
		JMP GOTO_READY
;<<<<<<<<<<< - KONCOWY KOD
;===========================
TS2_LVS
		
		JSR EMPTY_LINE_TEST
		CMP #"/"
		BEQ GET_FILE_PARAMS
		CMP #$1E
		BEQ GET_FILE_PARAMS
		RTS
GET_FILE_PARAMS
		LDY #$00
		STY $B7
		JSR SETUP_BA
		LDA #$01
		STA $B9
		STA $B8
		STA $BC
		LDA #$30
		STA $BB
		JSR SETUP_LINE
		JSR TEST_2CH_CUDZ
;ZWRACA W CARRY ZNALEZIENIE C = 0
;JAK ZNALEZIONY - W X PIERWSZY, W Y 2GI CUDZUSLOW
		BCC GFP2
		JMP GFP_NO_Q ;WEZ NAZWE Z LINII BEZ CUDZ		
GFP2		
		TXA
		TAY
		LDA #$20
		
	-	DEY
		BEQ GFP3
		STA ($D1),Y
		JMP -
;------------------------
;POBRANIE NAZWY POMIEDZY CUDZYSL
GFP3		
		LDY #$00
		
	-
		JSR GET_FROM_SCREEN
		CMP #$22
		BNE -

	-
		JSR $E632
		CMP #$22
		BEQ +
		STA ($BB),Y
		;STA $0400,Y
		INY
		BNE -
	+
		STY $B7
		
		SEI
		LDA #"/"

		LDY #$00
		STY $D0


		CLI
		
		JSR TEST_DIR_FILE
		BCS +
	-
		JSR CHANGE_DIR	
		JSR $E544
		JMP CONT_WITH_DIR
	+	
		JSR TEST_D64_FILE
		BCC -
		JSR TEST_M2I_FILE
		BCC -

		JSR TEST_2CH_CUDZ
		

	-	INY
		CPY #$28
		BCS CONT_LOAD_OR_SAVE
		LDA ($D1),Y
		CMP #$20
		BEQ -
GET_DRIVE_NR
		CMP #","
		BNE CONT_LOAD_OR_SAVE

-		INY
		CPY #$28
		BCS CONT_LOAD_OR_SAVE
		LDA ($D1),Y
		CMP #$20
		BEQ -
		CMP #$30
		BCC CONT_LOAD_OR_SAVE
		CMP #$3A
		BCS CONT_LOAD_OR_SAVE
		PHA
		AND #$0F
		STA $BA
		PLA
		CMP #$31
		BNE CONT_LOAD_OR_SAVE
		INY
		LDA ($D1),Y
		CMP #$30
		BNE +
		LDA #$0A
		BNE ++
	+	CMP #$31
		BNE CONT_LOAD_OR_SAVE
		LDA #$0B
	+	STA $BA


CONT_LOAD_OR_SAVE
		
		JSR EMPTY_LINE_TEST
		PHA
		JSR GO_CR
		PLA
		CMP #"/"
		BEQ +
		JMP ($0332)
	+	LDA #$00 ;03
		JMP GO_LOAD_FROM_TOKEN		
;------------
GFP_NO_Q ;WEZ NAZWE Z LINII BEZ CUDZ
		JSR EMPTY_LINE_TEST
		LDY #$00
		
	-
		JSR GET_FROM_SCREEN
		CMP #$20
		BEQ -

	-
		INY 
		CPY #$28
		BCC +
		RTS
	+
		JSR GET_FROM_SCREEN
		CMP #$20
		BEQ -
		LDY #$00
		BEQ +
	-
		JSR GET_FROM_SCREEN
		;JSR $E632
		CMP #$20
		BEQ ++
		CMP #$2C
		BEQ ++
	+	STA ($BB),Y
		;STA $0400,Y
		INY
		CPY #$10
		BNE -
	+
		STY $B7
		LDY $D3
		DEY
		JMP GET_DRIVE_NR 
;===========================
TS1_LVS
		LDX #$00
		
		JSR EMPTY_LINE_TEST
	-
		LDA ($D1),Y
		CMP LOADV1,X
		BNE TS1_LVS_01		
		INX
		INY
		CPX #4
		BNE -
		LDA #"/"
REPLACE_TOKEN
		PHA
		LDA ($D1),Y
		CMP #$20
		BEQ +
		CMP #$22
		BNE TYPE_MISMATCH
		JSR TEST_2CH_CUDZ
		BCC CLEARLINE
TYPE_MISMATCH
		LDX #22
		JMP ERROR_IN_X
	+	TYA
		PHA
		JSR TEST_2CH_CUDZ
		BCS TYPE_MISMATCH
		PLA
		TAY

	-	INY
		LDA ($D1),Y
		CMP #$20
		BEQ -
		CMP #$22
		BNE TYPE_MISMATCH
CLEARLINE
		DEX
		TXA
		TAY
		LDA #$20
	-	STA ($D1),Y
		DEY
		BNE -
		PLA
		STA ($D1),Y
		RTS
TS1_LVS_01		
		LDX #$00
		JSR EMPTY_LINE_TEST
	-
		LDA ($D1),Y
		CMP LOADV2,X
		BNE TS1_LVS_02		
		INX
		INY
		CPX #2
		BNE -
		LDA #"/"
		BNE REPLACE_TOKEN

TS1_LVS_02		
		LDX #$00
		JSR EMPTY_LINE_TEST
	-
		LDA ($D1),Y
		CMP SAVEV1,X
		BNE TS1_LVS_03		
		INX
		INY
		CPX #4
		BNE -
		LDA #$1E ;"^"
		BNE REPLACE_TOKEN
TS1_LVS_03
		LDX #$00
		JSR EMPTY_LINE_TEST
	-
		LDA ($D1),Y
		CMP SAVEV2,X
		BNE TS1_LVS_04
		INX
		INY
		CPX #2
		BNE -
		LDA #$1E;"^"
		BNE REPLACE_TOKEN
TS1_LVS_04
		LDX #$00
		JSR EMPTY_LINE_TEST
	-
		LDA ($D1),Y
		CMP VERYFV1,X
		BNE TS1_LVS_05
		INX
		INY
		CPX #6
		BNE -
		LDA #"/"
		JMP REPLACE_TOKEN
TS1_LVS_05
		LDX #$00
		JSR EMPTY_LINE_TEST
	-
		LDA ($D1),Y
		CMP VERYFV2,X
		BNE TS1_LVS_06
		INX
		INY
		CPX #2
		BNE -
		LDA #"/"
		JMP REPLACE_TOKEN
TS1_LVS_06
		RTS

LOADV1	.BYTE $0C,$0F,$01,$04
LOADV2	.BYTE $0C,$4F
SAVEV1	.BYTE $13,$01,$16,$05
SAVEV2	.BYTE $13,$41
VERYFV1	.BYTE $16,$05,$12,$09,$06,$19
VERYFV2	.BYTE $16,$45

;----------------------
; TAPE TURBO
;----------------------

;----------------------
; CONST
;----------------------
; HEADER STRUCTURE
HEADER_SAL = 0	  ; (2)
HEADER_EAL = 2	  ; (2)
HEADER_TRASH = 4	; (1)
HEADER_FNAME = 5	; (16)

HEADER_LEN = 192

; LOAD TIMER
TT_TIMER = 263

;----------------------
; VARIABLES
;----------------------
R6510 = $01	 ; 6510 ON CHIP 8 BIT
				; I/O REGISTER
VERCK = $0A	 ; 0=LOAD, 1=VERIFY
VERCKK = $93	; 0=LOAD, 1=VERIFY
TXTTAB = $2B	; POINTER: START OF
				;  BASIC TEXT

TSFCNT = $A3
RIPRTY = $AB	; CASSETTE SHORT CNT
SAL = $AC	   ; START OF PROGRAM
EAL = $AE	   ; END OF PROGRAM
TAPE1 = $B2	 ; POINTER: START OF
				;  TAPE BUFFER
FNLEN = $B7	 ; LENGTH OF FILE NAME
SA  = $B9	   ; SECONDARY ADDRESS
FNADR = $BB	 ; POINTER: FILE NAME
ROPRTY = $BD	; LOADED/SAVED BYTE
CAS1 = $C0	  ; TAPE MOTOR INTERLOCK
MEMUSS = $C3
SCHAR = $D7	 ; CRC OF LOADED BLOCK
TBUFFR = $033C  ; TAPE I/O BUFFER

SCROLY = $D011
EXTCOL = $D020
SIGVOL = $D418
CIAICR = $DC0D
TI2ALO = $DD04
TI2AHI = $DD05
CI2ICR = $DD0D
CI2CRA = $DD0E

CHROUT = $FFD2
;GETIN = $FFE4

;----------------------
; CODE
;----------------------
; LOAD EXAMPLE
TURBO_ABC

	LDA #$FF
	STA $010F
	
	JSR TT_LOAD
TT_ERROR
	LDA SCHAR
	BEQ +
	LDX #29
	JMP ERROR_IN_X

+
	LDA $010E
	CMP $2B
	BNE +
	LDA $010F
	CMP $2C
	BNE +
	LDA SAL
	STA $2D
	LDA SAL +1
	STA $2E
	JSR $A659
+	JMP GOTO_READY


;----------------------
; I/O INIT
;----------------------
IO_INIT = *
	SEI
	LDA SCROLY
	AND #%11101111
	STA SCROLY
	LDA #<TT_TIMER
	STA TI2ALO
	LDA #>TT_TIMER
	STA TI2AHI
	RTS


;----------------------
; LOAD/VERIFY
;
; SAL < START ADDRESS
; FNLEN < FILE NAME LENGTH
; FNADR < POINTER TO FILE NAME
; SCHAR > IF 0 CRC OK
;----------------------
TT_LOAD
; LOAD LOOP
TL1 JSR LOAD_HEADER
	JSR MOTOR_STOP
; PRINT 'FOUND'
BIT $9D
BPL TL2_A
	LDY #PMSG3_OFFS
	JSR PRINT_MESSAGE
	LDY #0
TL2 LDA TBUFFR+HEADER_FNAME,Y
	JSR CHROUT
	INY
	CPY #16
	BCC TL2

		LDA #<PMSG4
		LDY #>PMSG4
		JSR $AB1E
TL2_A
		LDX TBUFFR+HEADER_SAL+1
		LDA TBUFFR+HEADER_SAL
		STA SAL
		STX SAL+1
		JSR WRITE_HEX_WORD
		BIT $9D
		BPL +
		LDA #<PMSG6
		LDY #>PMSG6
		JSR $AB1E
	+	LDX TBUFFR+HEADER_EAL+1
		LDA TBUFFR+HEADER_EAL
		STA EAL
		STX EAL+1
		JSR WRITE_HEX_WORD
		BIT $9D
		BPL +
		LDA #<PMSG7
		LDY #>PMSG7
		JSR $AB1E
		LDA #$00
		LDX $AB
		JSR $BDCD

		LDA #<PMSG8
		LDY #>PMSG8
		JSR $AB1E
	+
		LDA TBUFFR+HEADER_EAL
		SEC
		SBC TBUFFR+HEADER_SAL
		PHA
		LDA TBUFFR+HEADER_EAL+1
		SBC TBUFFR+HEADER_SAL+1
		TAX
		PLA
		JSR WRITE_HEX_WORD

		LDA #$10
		LDX #<TBUFFR+HEADER_FNAME
		LDY #>TBUFFR+HEADER_FNAME
		JSR $FFBD
		JSR KOPIUJ_NAZWE_ZBIORU
	
		LDA SAL
		STA $010E
		LDA SAL+1
		STA $010F

BIT $9D
BPL TL5_A	
	
	LDA #$04
	STA $02
	LDX #0
	
TL4 LDA $DC01
	CMP #$EF
	BEQ TL5
	CMP #$7F
	BNE +
	JMP GOTO_READY
+
	DEY
	BNE TL4
	DEX 
	BNE TL4
	DEC $02
	BNE TL4	
	

; PRINT 'LOAD/VERIFY-ING'
TL5
	CLI
	LDA #$0D
	JSR $E716
	LDY #$49
	JSR $F12F
TL5_A
; COMPUTER COUNTER
;	SEC
;	LDA TBUFFR+HEADER_EAL
;	SBC TBUFFR+HEADER_SAL
;	STA EAL
;	LDA TBUFFR+HEADER_EAL+1
;	SBC TBUFFR+HEADER_SAL+1
;	STA EAL+1
	
;----- Paragraph @ABCTURBO@ -----

	JSR LOAD_DATA

; COMPUTE CRC
	JSR MOTOR_STOP
	LDA #$00
	STA $C6

	CLI
	LDA ROPRTY
	EOR SCHAR
	STA SCHAR
	RTS

;----------------------
; LOAD HEADER BLOCK
;----------------------
LOAD_HEADER
LH1 JSR LOAD_PILOT
	CMP #0
	BEQ LH1
; STORE HEADER TYPE
   STA $AB

;   LDY #0
LH2 JSR LOAD_BYTE
	STA TBUFFR,Y
	INY
	CPY #HEADER_LEN
	BCC LH2
	BCS IO_END

;----------------------
; LOAD DATA BLOCK
;
; SAL < START ADDRESS
; EAL < LOADED BYTES COUNTER
;----------------------
LOAD_DATA
	LDY #12
-
	LDA LD000,Y
	STA $0100,Y
	DEY
	BPL -
	JMP LD00
LD000
	INC $01
	STA (SAL),Y
	DEC $01
	JMP LD1A
LD00
	JSR LOAD_PILOT
	LDY #$00
LD1 
	JSR LOAD_BYTE
	JMP $0100
LD1A
LD3 EOR SCHAR
	STA SCHAR
	
	LDA $DC01
	CMP #$7F
	BNE +
	JSR IO_END

	JMP TT_ERROR
	
+	INC SAL
	BNE +
	INC SAL +1
+
	LDA EAL
	CMP SAL
	BNE LD1
	LDA EAL +1
	CMP SAL +1
	BNE LD1

	JSR LOAD_BYTE
;   JMP IO_END

;----------------------
; IO END
;----------------------
IO_END
	LDA SCROLY
	ORA #%00010000
	STA SCROLY
	CLI
;   JMP MOTOR_STOP

;----------------------
; STOP CASSETTE MOTOR
;----------------------
MOTOR_STOP
	LDA R6510
	ORA #%00100000
	STA R6510
	sta $c0
	LDA #$0E
	STA $D020
	RTS

;----------------------
; START CASSETTE MOTOR
;----------------------
MOTOR_START
	LDA R6510
	AND #%11011111
	STA R6510
	sta $c0
	RTS

;----------------------
; TEST CASSETE SENSE
;
; Z > CLEAR IF PLAY PRESSED
;----------------------
CAS_SENSE
	LDA #%00010000
	BIT R6510
	RTS

;----------------------
; LOAD PILOT
;----------------------
LOAD_PILOT
; WAIT FOR PLAY PRESSED
	JSR CAS_SENSE
	BEQ LP2
LOAD_PILOT2
	JSR $E544
LP2_B
	LDY #PMSG0_OFFS
	JSR PRINT_MESSAGE
	
LP1 JSR CAS_SENSE
	BEQ +
	LDA $DC01
	AND #$80
	BNE LP1
	JMP GOTO_READY
+
	BIT $9D
	BPL LP2
	LDY #PMSG2_OFFS
	JSR PRINT_MESSAGE

LP2 JSR MOTOR_START
	JSR IO_INIT

LP3 JSR LOAD_BIT
	ROL ROPRTY
	LDA ROPRTY
	CMP #2
	BNE LP3
	LDY #9
LP4 JSR LOAD_BYTE
	CMP #2
	BEQ LP4
LP5 CPY ROPRTY
	BNE LP3
	JSR LOAD_BYTE
	DEY
	BNE LP5

; CRC INIT
	STY SCHAR
	RTS

;----------------------
; LOAD BYTE
;
; .A/ROPRTY > LOADED BYTE VALUE
;----------------------
LOAD_BYTE
	LDA #%00000001
	STA ROPRTY
LY1 JSR LOAD_BIT
	LDA #$00
	BCC +
	LDA #$02
+	STA $D020
	ROL ROPRTY
	BCC LY1
	LDA ROPRTY
	RTS

;----------------------
; LOAD BIT
;
; C > LOADED BIT VALUE
;----------------------
LOAD_BIT
	LDA #$10
LI1  BIT CIAICR
	BEQ LI1
	LDA CI2ICR
	STA SIGVOL
	NOP
	NOP	
	LSR 
	LDA #%00011001
	STA CI2CRA
	RTS

;----------------------
; PRINT MESSAGE
;
; .Y < MESSAGE OFFSET
;----------------------
PRINT_MESSAGE
PM1 LDA PMSG,Y
	PHP
	AND #$7F
	JSR $E716
	INY
	PLP
	BPL PM1
	RTS

PMSG
PMSG0_OFFS = *-PMSG
	.BYTE 13
	.TEXT "LOAD"
	.BYTE $22,$22
	.TEXT ",7,1"
	.BYTE $0D,$0D
	.TEXT "PRESS PLAY ON TAP"
	.BYTE $C5
PMSG2_OFFS = *-PMSG
	.BYTE $0D
	.TEXT "OK"
	.BYTE $8D
PMSG3_OFFS = *-PMSG
	.BYTE $0D
	.TEXT "FOUND"
	.BYTE $A0
PMSG4 
.BYTE 13,13
.TEXT "LOAD ADRESS : $"
.BYTE 0
PMSG5
.TEXT " DEC "
.BYTE 0
PMSG6
.BYTE 13
.TEXT "END  ADRESS : $"
.BYTE 0
PMSG7
.BYTE 13
.TEXT "HEADER TYPE : #"
.BYTE 0
PMSG8
.BYTE 13
.TEXT "FILE LENGTH : $"
.BYTE 0

WRITE_HEX_WORD
		BIT $9D
		BMI +
		RTS
	+
		PHA
		TXA
		PHA
		JSR PRH
		PLA
		TAX
		PLA
		PHA
		JSR PRH
		TXA
		PHA
		
		LDA #<PMSG5
		LDY #>PMSG5
		JSR $AB1E
		PLA
		TAY
		PLA
		TAX
		TYA
		
		JMP $BDCD
		
___EOF_ABC

PRH      PHA
         LSR A
         LSR A
         LSR A
         LSR A
         JSR CONV1
         PLA
CONV1    AND #$0F
         ORA #$30
         CMP #$3A
         BCC CONVEND
         ADC #$06
CONVEND  JMP $E716
;========================
;----- Paragraph @TURBOSAVE@ -----
FC3SAVE
		LDA $BA
		CMP #$08
		BCS +
	-	JMP ($8000)
	+
		CMP #$0C
		BCS -
		LDA #$1B
		STA $D011
		LDX #3
	-
		LDA $2B,X
		STA $AC,X
		DEX
		BPL -
			
		BIT $9D
		BPL +
		JSR WHITE_COLOR
		JSR KOPIUJ_NAZWE_ZBIORU
		JSR GET_SAVE_AREA
	+
		JSR CALC_SAVE_DATA
		JSR INITDISK
		JSR IEC_CREATE_FILE
		BCC +
		JMP GOTO_READY
	+	
		LDA $93
		PHA
		BIT $9D
		BPL +
		JSR PRT_SAVE_SVENAME
		JSR GO_CR
	+
		JSR MEW_FOR_SAVE
		
		SEI
		PLA
		STA $93
		LDX #10
	-	LDA SAVE_DATAS,X
		STA $0100,X
		DEX
		BPL -
		JMP +
SAVE_DATAS
		INC $01
		LDA ($6B),Y
		DEC $01
		JMP SBT
		
	+	LDX #$FF
		LDA $6A
		BNE +
		LDX $93
	+	INX
		TXA
		
		JSR SBT
		LDA $6B
		CLC
		ADC #$02
		PHP
		JSR SBT
		PLP
		LDA $6C
		ADC #$00
		JSR SBT
		LDY #$02
	-		
		JSR $0100				
		INY
	+	CPY $93
		BNE -
		LDA #$0E
		STA $D020
		LDA $6A
		BEQ SAVE_KONIEC
		JSR SET_SAVE_DATA
		
		LDX #$FF
		LDA $6A
		BNE +
		LDX $93
	+	INX
		TXA
		
		JSR SBT
		JMP -
SAVE_KONIEC		
		CLI
		LDA #$0E
		STA $D020
		BIT $9D
		BMI +
		CLC
		JMP DETACH_CART
		+
		JSR STATUS
		
		JMP GOTO_READY
;=================
PRT_SAVE_SVENAME
		JSR PRT_SAVING ;PRINT "SAVING"
		BMI +
		RTS

	+	LDY $B7 ;PRINT SAVENAME
		BEQ +
		LDY #$00
	-	
		LDA ($BB),Y
		JSR $E716
		INY
		CPY $B7
		BNE -
				
	+	RTS
;---
PRT_SAVING ;COMM "SAVING"

		LDY #$51
		BIT $9D
		BPL +
		
	-
		LDA $F0BD,Y
		PHP
		AND #$7F
		JSR $E716
		INY
		PLP
		BPL -
		
	+	CLC

		RTS
;=================
MEW_FOR_SAVE
		LDA #$07
		STA $93
		LDA #<CODE_SAVE
		LDY #>CODE_SAVE
		LDX #$05
		JSR FC3_MW
		LDA #$9C ;M-E $059C
		JSR $FFA8 
		LDA #$05
		JSR $FFA8
		LDA #$1B
		STA $D011
		JSR $FFAE
		SEI
		LDA #$13
		STA $DD00
		CLI
		LDY #$00
		DEX
		BNE *-1
		DEY
		BNE *-4
		CLC
		RTS
;=================
IEC_CREATE_FILE

		LDY #$00
		STY $90
		LDA $BA
		JSR $ED0C
		LDA #$61
		STA $B9
		ORA #$F0
		JSR $EDB9
		LDA $90
		BPL +
		SEC
		RTS
	+
	-
		LDA ($BB),Y
		JSR $EDDD
		INY
		CPY $B7
		BNE -
		JSR $F654
		
		LDA $BA
		JSR $FFB4
		LDA #$6F
		JSR $FF96
		
		JSR $FFA5
		TAY
cpy #$30
beq +
lda #$0d
jsr $ffd2
JSR $FFD2
tya
jsr $ffd2
+
	-
		JSR $FFA5
cpy #$30
beq +
jsr $ffd2
+
		CMP #$0D
		BNE -
		JSR $FFD2

		JSR $FFAB
		CPY #$30
		CLC
		BEQ +
		SEC
	+	LDA #$00
		RTS
;=================
CALC_SAVE_DATA
		LDX #3
	-	LDA $AC,X
		STA $6B,X
		DEX
		BPL -
		INX
		STX $6A
		LDA $6B
		SEC
		SBC #$02
		STA $6B
		LDA $6C
		SBC #$00
		STA $6C
		LDA $6D
		SEC
		SBC $6B
		STA $6D
		LDA $6E
		SBC $6C
		STA $6E
		
	-	LDA $6E
		BNE +
		LDA $6D
		CMP #$FF
		BEQ +
		BNE ++
	+	INC $6A
		LDA $6D
		SEC
		SBC #$FE
		STA $6D
		LDA $6E
		SBC #$00
		STA $6E
		JMP -
	+
		INC $6A
		JMP SSD2		
SET_SAVE_DATA
		LDY #$00
		LDA $6B
		CLC
		ADC #$FE
		STA $6B
		BCC SSD2
		INC $6C
SSD2
		LDA #$FE
		DEC $6A
		BNE +
		LDA $6D
	+	STA $93
		RTS
;=================
GET_SAVE_AREA
		LDY #$27
		LDA #$20
	-
		STA ($D1),Y
		DEY
		BPL -
		
		LDA #<TX_S_AREA
		LDY #>TX_S_AREA
		JSR $AB1E
		LDA $2C
		JSR PRH
		LDA $2B
		JSR PRH
		
		LDA #<TX_TO_AREA 
		LDY #>TX_TO_AREA
		JSR $AB1E
		LDA $2E
		JSR PRH
		LDA $2D
		JSR PRH

		LDA #$9D
		LDX #15
	-
		JSR $E716
		DEX
		BNE -
		
		JSR GET4HEX
		STA $AC
		STY $AD
		LDA #$1D
		LDX #8
	-
		JSR $E716
		DEX
		BNE -
;---
GET4HEX
		LDA $D3
		STA $6A
		LDA #$00
		STA $6B

		JSR GET1HEX

		LDY $CF
		BNE *-2
		STY $C6
		INY
		STY $CC
		
		JSR CLEAR_HEX
		LDY $6A
		DEY
		JSR READ_HEX_BT
		STA $AF
		JSR READ_HEX_BT
		STA $AE
		LDY $AF		
	-
		RTS
;---
READ_HEX_BT
		JSR READ_HEX
		ASL
		ASL
		ASL
		ASL
		STA $AE
		JSR READ_HEX
		ORA $AE
		RTS
READ_HEX
		INY
		LDA ($D1),Y
		CMP #$30
		BCS +
		ADC #$09
	+	AND #$0F
		RTS
GET1HEX
		JSR CLEAR_HEX
		LDA #$00
		STA $C6
		STA $CC
		JSR $FFE4
		BEQ *-3
		CMP #$0D
		BNE +
		LDY #$00
		LDX $6B
		CPX #3
		BEQ -
		LDA #$1D
	-	JSR $E716
		INX
		CPX #3
		BNE -
		JMP CLEAR_HEX
	+	CMP #$1D ; W PRAWO
		BNE TEST_LEWO
W_PRAWO
		LDA #$1D
		LDX $6B
		CPX #3
		BEQ +
		JSR $E716
		INC $6B
		JMP GET1HEX
	+	LDA #$9D
	-
		JSR $E716
		DEX
		BNE -
		STX $6B
		JMP GET1HEX
TEST_LEWO CMP #$9D
		BNE TEST_HCYFR
		LDX $6B
		BEQ +
		DEC $6B
		JSR $E716
		JMP GET1HEX
		
	+	LDA #$1D
		LDX #3
		STX $6B
	-
		JSR $E716
		DEX
		BNE -
		BEQ GET1HEX
TEST_HCYFR
		CMP #$30
		BCC GET1HEX
		CMP #$3A
		BCC DRUKUJ_CYFRE
		CMP #$41
		BCC GET1HEX
		CMP #$47
		BCS GET1HEX
		AND #$0F
DRUKUJ_CYFRE
		LDY $D3
		STA ($D1),Y
		JMP W_PRAWO
;---
CLEAR_HEX
		LDY $6A
		LDX #5

	-
		LDA ($D1),Y
		AND #$7F
		STA ($D1),Y
		INY
		DEX
		BNE -
		RTS
;-----------
TX_S_AREA
		.TEXT "SAVE AREA FROM : $"
		.BYTE 0
TX_TO_AREA
		.TEXT " TO : $"
		.BYTE 0
;-------------------------------
HF_FILE
.BINARY "/C64PROJECT/C_SYSTEM/HEAD FIT.PRG",2
         .TEXT "WEGI"
MY_CORE_NAME
.BYTE 13
.TEXT "     MULTI-ACTION-REPLAY SD2IEC CORE"
.BYTE 13,0
TEXT_HELP
.BYTE 13
.TEXT "F1 - PARRENT DIR / F2 - ROOT DIR"
.BYTE 13
.TEXT "F3 - RUN  / F4 - ZAP"
.BYTE 13
.TEXT "F5 - LOAD / F6 - RESTART CART"
.BYTE 13
.TEXT "F7 - DIR  / F8 - LIST"
.BYTE 13,13
.TEXT "_ - HEAD FIT / _T - TURBOASS."
.BYTE 13,13
.TEXT "@8,@9,@10,@11 - SELECT DEVICE NR"
.BYTE 13
.TEXT "@I - INIT DISK / @ - READ STATUS"
.BYTE 13
.TEXT "@... - SEND STRING TO DEVICE"
.BYTE 13
.TEXT "LOAD"
.BYTE $22,$22
.TEXT ",7 - TAPE ABC TURBO LOAD"

.BYTE 13,0
;==============
FREEZ   
         LDA #$7F
         STA $DD0D
FZ1      LDA $DD0E
         LDA $DD0F
         LDA #$7C
         STA $DD0D
         LDA #$00    ;TIMERSTOP
         STA $DD0E
         STA $DD0F
         LDA $DC0E
         LDA $DC0F
         LDA #$00    ;TIMERSTOP
         STA $DC0E
         STA $DC0F
         LDA $DD0D
         
		LDA #$2F
		STA $00
		LDA #$37
		STA $01
		LDA #$0B
		STA $D011
		LDA #$0E
		STA $D020
		ldx #$00
		LDA #$43
		STA $DE00
		dex
		bne *-1
		LDA #$23
		STA $DE00
		dex
		bne *-1
		
		LDX #$08
	-
		LDA $FF00,X
		STA $9F00,X
		INX
		BNE -
		LDA #$FB
		CMP $D012
		BNE *-3
		LDA #$9F
		PHA
		LDA #<KONCZFREEZ-1
		PHA
		LDX #$00
		RTS
__FINE_COD
*= $9E00
LOADER_FC3
		JMP FC3LOAD
		JMP FC3SAVE
;---
SBT

		PHA
		LSR
		LSR
		LSR
		LSR
		TAX
		BIT $DD00
		BPL *-3

	-
		LDA $D012
		CMP #$31
		BCC +
		AND #$06
		CMP #$02
		BEQ -
	+
		LDA #$07
		STA $DD00
		LDA FCTAB1,X
		NOP
		NOP
		STA $DD00
		LSR
		LSR
		AND #$F7
		STA $DD00
		PLA
		AND #$0F
		TAX
		LDA FCTAB1,X
		STA $DD00
		LSR
		LSR
		AND #$F7
		STA $DD00
		LDA #$17
		;NOP
		;NOP
		STY $D020
		STA $DD00
		RTS		
;======
FCTAB1
		.BYTE $07,$87,$27,$A7,$47,$C7,$67,$E7
		.BYTE $17,$97,$37,$B7,$57,$D7,$77,$F7
;=====

GET4FC3PAL
		LDA MY_NTSC
		BEQ GET4FC3NTSC
		
		BIT $DD00
		BVS *-3
		LDY #$03
		NOP
		LDX $01
		
	-
		LDA $DD00
		LSR
		LSR
		NOP
		NOP
		ORA $DD00
		LSR
		LSR
		NOP
		NOP
		ORA $DD00
		LSR
		LSR
		NOP
		NOP
		ORA $DD00
		STA $00C1,Y
		DEY
		BPL -
		RTS
_LEN_PAL = *-GET4FC3PAL
;---		
GET4FC3NTSC

		BIT $DD00
		BVS *-3
		LDY #$03
		NOP
		LDX $01
		
	-
		LDA $DD00
		LSR
		LSR
		NOP
		NOP
		NOP
		ORA $DD00
		LSR
		LSR
		NOP
		NOP
		ORA $DD00
		LSR
		LSR
		NOP
		NOP
		ORA $DD00
		STA $00C1,Y
		DEY
		BPL -
		RTS
_LEN_NTSC = *-GET4FC3NTSC
;==========
*=$9F00
CORE_SWITCH
;TRUE CORE SWITCH
.LOGICAL $DF00
NOP
NOP
NOP
NOP
NOP
NOP
NOP
NOP
FASTLOAD
		JSR SETUP_PORT_01
		PHP
		PHA
		LDA #$00
		STA $DE00
		PLA
		PLP
		JMP LOADER_FC3
		
SETUP_PORT_01
		PHP
		SEI
		PHA
		LDA #$2F
		STA $00
		LDA #$37
		STA $01
		STA $C0
		PLA
		PLP
		RTS
SAVE_VEC
		JSR SETUP_PORT_01
		PHP
		PHA
		LDA #$00
		STA $DE00
		PLA
		PLP
		JMP LOADER_FC3+3
DETACH_CART
		JSR SETUP_PORT_01
		PHP
		PHA
		LDA #$02
		STA $DE00
		PLA
		PLP
		CLI
		RTS
M_WAIT
		LDA #$00
		STA $DE00
		JMP M_WAIT2
ZRESETUJ
		SEI
		CLD
		JSR SETUP_PORT_01
		LDA #$0B
		STA $D011
		LDA #$00
		STA $DE00
		JMP ($8000)
GOTO_NMI
		SEI
		CLD
		JMP FREEZ +$6000
KONCZFREEZ
		LDA #$00
		STA $DE00
		JMP ZRESETUJ

		
USTAW_CARTA
		JSR SETUP_PORT_01
		PHP
		SEI
		PHA
		LDA #$00
		STA $DE00
		PLA
		PLP
		RTS
WIZYTOWKA
	.TEXT "WEGICORE"
.HERE
*=$9FFA
;VECTORS FOR ULTIMAX MODE 
.BYTE <GOTO_NMI,$FF ;>GOTO_NMI
.BYTE <GOTO_NMI,$FF ;>GOTO_NMI
.BYTE <GOTO_NMI,$FF ;>GOTO_NMI
;===============
.BINARY "/C64PROJECT/C_SYSTEM/tasm51flt.prg",2

